using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Http;
using UmbExtendAPIControllerProject.Models;
using umbraco.cms.businesslogic;
using Umbraco.Web.WebApi;

namespace UmbExtendAPIControllerProject.Controllers
{
    public class UmbExtendApiController : UmbracoApiController
    {
        ImportProducts myImportProducts = new ImportProducts();
        List<Product> productList = new List<Product>();

        public ImportProducts GetTestImportProducts()
        {
            int parentNodeId = 1053; // Get this from the properties tab in Umbraco of your Products Container (the content node)
            string typeStr = "Product";  // This needs to match your Document Type alias
            
            // 1. Get a list of all product IDs that we have in the DB with the last Update date.
            var nodes = Services.ContentService.GetChildren(parentNodeId).Where(x => x.ContentType.Alias == typeStr);

            // create a dictionary
            Dictionary<int, Product> dictProducts = new Dictionary<int, Product>();
            // if we have nodes
            if (nodes.Any())
            {
                foreach (var node in nodes)
                {
                    var curProduct = new Product();
                    curProduct.Id = Convert.ToInt32(node.GetValue("productID"));
                    curProduct.Name = node.GetValue("productName").ToString(); 
                    // extend this for lastUpdated or similar..

                     // add to the dictionary with the ID as key so we can quickly check if it's there already
                    if (!dictProducts.ContainsKey(curProduct.Id))
                    {
                        dictProducts.Add(curProduct.Id, curProduct);
                    }
                }
            }
            System.Threading.Thread.Sleep(2000);  // A short delay to demo the ajax spinner!  TAKE THIS OUT!

            // change this connstr to match your SQL server and NORTWND DB name (perhaps you won't have int. sec. too?)
            string connStr = @"Data Source=.\SQLEXPRESS;Initial Catalog=NORTHWND;Integrated Security=True";
            // When you're happy it's working remove the TOP 10 part so that *all* products are created (bit annoying to delete them all though!)             
            string queryStr = "SELECT TOP 10 ProductID, ProductName, UnitPrice FROM products;";

            using (SqlConnection sqlConn = new SqlConnection(connStr))
            {
                SqlCommand cmd = new SqlCommand(queryStr, sqlConn);
                try
                {
                    sqlConn.Open();
                    SqlDataReader reader = cmd.ExecuteReader();
                    while (reader.Read())
                    {
                        // debugging
                        //System.Diagnostics.Debug.WriteLine("\t{0}\t{1}\t{2}", reader[0], reader[1], reader[2]);
                        Product newProduct = new Product { Id = (int)reader[0], Name = reader[1].ToString(), Price = (decimal)reader[2] };
                        
                        // if it's a new product (TODO - check the last updated instead and update o/w)
                        if (!dictProducts.ContainsKey(newProduct.Id)) {
                            string contentName = reader[0].ToString() + " - " + reader[1].ToString();

                            var umbProduct = Services.ContentService.CreateContent(contentName, parentNodeId, typeStr);
                            umbProduct.SetValue("productID", reader[0].ToString());
                            umbProduct.SetValue("productName", reader[1].ToString());
                            umbProduct.SetValue("unitPrice", reader[2].ToString());
                            Services.ContentService.Save(umbProduct);
                            // add to the list for the response - could give the editor a list of new products in the backoffice
                            productList.Add(newProduct);
                        }
                    }
                    reader.Close();
                }
                catch (Exception ex)
                {
                    // TODO - Handle this better
                    System.Diagnostics.Debug.WriteLine(ex.Message);
                }

            }
          
            myImportProducts.LastUpdate = DateTime.Now;
            myImportProducts.Results = "Import completed successfully";
            myImportProducts.Products = productList.ToArray();
            return myImportProducts;
        }

        // the following methods are from the Umbraco video examples - I've left them here for 
        // reference
        /* public IEnumerable<Importer> GetAllImport()
        {
            return myImportProducts;
        }

        public Product GetProductById(int id)
        {
            var product = products.FirstOrDefault((p) => p.Id == id);
                if (product == null)
                {
                    throw new HttpResponseException(HttpStatusCode.NotFound);
                }
            return product;
        } */
    }
}